local JQL_MISSABLE_STATE_NOT_MISSABLE = 0
local JQL_MISSABLE_STATE_MISSABLE = 1
local JQL_MISSABLE_STATE_MISSED = 2

local missableQuests = {
	[4818] = {4255},			--To Auridon
	[5055] = {4255, 5058},		--Missive to the Queen
	[5058] = {4255, 5055},		--All The Fuss
	[4211] = {4217},			--To Tanzelwil
	[4366] = {4293},			--To Mathiisen
	[4549] = {4330},			--Back to Skywatch
	[4368] = {4330},			--To Skywatch
	[4365] = {4355},			--To Dawnbreak
	[4357] = {4260},			--To Firsthold
	[4896] = {4943},			--The Great Tree
	[4953] = {4943, 4896},		--Trouble at the Tree
	[5072] = {4593},			--Aid for Bramblebreach
	[4657] = {4586},			--The Spinner's Tale
	[4853] = {4574},			--Woodhearth
	[4744] = {4739},			--Before the Storm
	[4821] = {4546},			--Report to Marbruk
	[5088] = {4546},			--Naemon's Return
	[4790] = {4546, 4601, 4608},--Breaking the Ward
	[4850] = {4690},			--Shades of Green
	[5009] = {4193},			--The Siege of Velyn Harbor
	[5006] = {4193},			--To Velyn Harbor
	[4456] = {4124},			--The Hound's Plan
	[4477] = {4143},			--A Wedding to Attend
	[4544] = {4460},			--The Dark Mane
	[5093] = {4460},			--Moons Over Grimwatch
	[4798] = {4652},			--Eye on Arenthia
	[4710] = {4652, 5091, 4759},--Hallowed To Arenthia
	[5091] = {4460, 4710, 4759},--Hallowed To Grimwatch
	[4759] = {4712, 4710, 5091},--Hallowed to Rawl'kha
	[5092] = {4712},			--The Champions at Rawl'kha
	[4697] = {4712},			--To Rawl'kha
	[4799] = {4712},			--To Saifa in Rawl'kha
	[4709] = {4479},			--The Path to Moonmont
	[4802] = {4479},			--To Moonmont
	[4711] = {4550},			--To Dune
	[4466] = {4431, 4454, 4344},--The Broken Spearhead
	[4510] = {4466, 4514},		--The Spearhead's Captain
	[4514] = {4510, 4476},		--The Spearhead's Crew
	[3026] = {3060},			--The Wyrd Sisters
	[3183] = {3191},			--To the Wyrd Tree
	[3283] = {974},				--Werewolves to the North
	[3184] = {3027},			--The Glenumbra Moors
	[3330] = {3064},			--Retaking Camlorn
	[4558] = {3082},			--Taking the Fight to the Enemy
	[5053] = {3082},			--The Lost Patrol
	[4443] = {2552},			--To Alcaire Castle
	[5052] = {1536},			--An Offering to Azura
	[1735] = {1536},			--Unanswered Questions
	[5050] = {2495},			--Waiting for Word
	[4901] = {4902},			--The Road to Rivenspire
	[4949] = {2130, 3333},		--Favor for the Queen
	[4694] = {2130},			--Word from the Throne
	[4816] = {2184},			--A Blessing for the Dead
	[4817] = {2222},			--Tracking the Hand
	[2193] = {2251},			--The Scholar of Bergama
	[4761] = {2222},			--Trouble at Tava's Blessing
	[2240] = {2997},			--Shiri's Research
	[2403] = {2997},			--The Search for Shiri
	[3566] = {1799},			--Kingdom in Mourning
	[4991] = {1799},			--Dark Wings
	[3281] = {4899},			--Leading the Stand
	[3530] = {1834},			--Destroying the Dark Witnesses
	[4992] = {1834},			--Searching for the Searchers
	[4993] = {4891},			--Report to Evermore
	[4988] = {4912},			--Rendezvous at the Pass
	[4994] = {4912},			--Imperial Curiosity
	[4978] = {4959},			--Striking Back
	[3990] = {3987, 3995, 3992},--A Beginning at Bleakrock
	[4028] = {4026},			--Breaking the Tide
	[4026] = {4028},			--Zeren in Peril
	[4051] = {3585},			--Warning Davon's Watch
	[5041] = {3585, 5042},		--To Aid Davon's Watch
	[5042] = {3585, 5041},		--Assisting Davon's Watch
	[3589] = {3734},			--Quiet the Ringing Bell
	[3855] = {3615},			--Mystery of Othrenis
	[5044] = {3734, 3618},		--To the Mountain
	[3618] = {3734},			--To Ash Mountain
	[5043] = {3584},			--A Higher Priority
	[3737] = {3584},			--In With the Tide
	[3671] = {3632},			--To Fort Virak
	[5040] = {3632},			--Taking Precautions
	[3635] = {3695},			--City at the Spire
	[3698] = {3826},			--To the Tormented Spire
	[4894] = {5057},			--A Letter for Deshaan
	[3958] = {3610},			--The Llodos Plague
	[3653] = {3658},			--Ratting Them Out
	[3658] = {3653},			--A Timely Matter
	[3955] = {3673},			--Tracking the Plague
	[3956] = {4453},			--Message to Mournhold
	[5103] = {3817},			--Mournhold Market Misery
	[3966] = {3820},			--Chasing the Magistrix
	[3819] = {3749},			--Healing Hearts
	[4163] = {3686},			--Onward to Shadowfen
	[5013] = {3686},			--Hushed Whispers
	[3690] = {4587, 5015},		--Scouring the Mire
	[5015] = {4587, 3690},		--Eyes of the Enemy
	[3815] = {4606},			--Cracking the Egg
	[5016] = {4606, 3815},		--Children of the Hist
	[4646] = {3909},			--The Mnemic Egg
	[4152] = {4058},			--Swamp to Snow
	[4197] = {4062},			--Sounds of Alarm
	[4177] = {4150},			--Victory at Morvunskar
	[4169] = {4069},			--Of Councils and Kings
	[4087] = {4116},			--Sneak Peak
	[3977] = {3928},			--To Vernim Woods
	[4225] = {4153},			--To Nimalten
	[4286] = {3978},			--Pinepeak Caverns
	[5035] = {3978},			--Calling Hakra
	[4184] = {3978},			--To Pinepeak Caverns
	[5034] = {4147},			--A Grave Situation
	[3981] = {4147},			--To Taarengrav
	[5036] = {4139},			--Honrich Tower
	[4185] = {4139},			--To Honrich Tower
	[5104] = {4139},			--The Shards of Wuuthrad
	[4273] = {4186},			--To the King
	[4654] = {4679},			--An Unusual Circumstance
	[4679] = {4654},			--The Shadow's Embrace
	[5774] = {5769},			--A Leaf in the Wind
	[5775] = {5768},			--Holding Court
	[4656] = {4432},			--Tharayya's Trail
	[1804] = {1803},			--Sunken Knowledge
	[1803] = {1804},			--The Water Stone
	[3732] = {3799},			--Overrun
	[3802] = {3678},			--What Happened at Murkwater
	[3598] = {3595},			--Giving for the Greater Good
	[3595] = {3598},			--Wayward Son
	[4370] = {4364, 4369},		--A Bargain With Shadows
	[4364] = {4370, 4369},		--A Thorn in Your Side
	[4369] = {4370, 4364},		--The Will of the Worm
	[5920] = {5804},			--Breaking Through the Fog
	[5073] = {5077, 5075, 3856},--Aicessar's Invitation
	[5077] = {5073, 5075, 3856},--Basile's Invitation
	[5075] = {5073, 5077, 3856},--Hilan's Invitation
	[5071] = {5074, 5076, 3916},--Curinure's Invitation
	[5074] = {5071, 5076, 3916},--Rudrasa's Invitation
	[5076] = {5071, 5074, 3916},--Nemarc's Invitation
	[4767] = {4967, 4997},		--One of the Undaunted
	[4967] = {4767, 4997},		--One of the Undaunted
	[4997] = {4767, 4967},		--One of the Undaunted
	[5804] = {4296, 6143, 6324, 6455, 6646},	--Broken Bonds
	[6143] = {4296, 5804, 6324, 6455, 6646},	--The Mind Trap
	[6324] = {4296, 5804, 6143, 6455, 6646},	--Bright Moons, Warm Sands
	[6455] = {4296, 5804, 6143, 6324, 6646},	--Bound in Blood
	[6646] = {4296, 5804, 6143, 6324, 6455},	--The Gates of Adamant
	[3345] = {3343},			--The End of Extortion
	[3982] = {3840},			--Bound to the Bog
	[5506] = {5473},			--Scouting the Memorial District
	[5508] = {5490},			--Scouting the Arboretum
	[5510] = {5477},			--Scouting the Arena District
	[5511] = {5489},			--Scouting the Elven Gardens
	[5512] = {5483},			--Scouting the Nobles District
	[5513] = {5480},			--Scouting the Temple District
	[4974] = {4833},			--Brackenleaf's Briars
}

function JournalQuestLog.GetIsMissable(questId)
	local quest = missableQuests[questId]
	local isMissable
	if quest == nil then isMissable = JQL_MISSABLE_STATE_NOT_MISSABLE
	else
		isMissable = JQL_MISSABLE_STATE_MISSABLE
		for i = 1,#quest do
			local questInfo = GetCompletedQuestInfo(quest[i])
			if questInfo ~= "" then isMissable = JQL_MISSABLE_STATE_MISSED
			end
		end
	end
	return isMissable
end